AJS.$(document).ready(function() {
    
    var TableColumnsEnum = {
            checkbox: 0,
            fullname: 1,
            username: 2,
            holidayScheme: 3,
            workweekScheme: 4,
            teams: 5,
            actions: 6
        };
	
    // bulk selection
    function getSelectedUsers() {
        var users = new Array();
        usersTable.$("input:checked", {"filter":"applied"}).each(function (id, element) {
            users.push(element.value);
        });
        return users;
    }
   
    function bulkSelect(doSelect) {
        usersTable.$("input[name='userCheckbox']", {"filter":"applied"}).each(function (id, element) {
            element.checked = doSelect;
        });
        updateSelectedButton();
    }
   
    AJS.$("input[name='bulkSelect']").each(function (id, element) {
        element.addEventListener("click", function () {
            bulkSelect(element.checked == true);
        });
    });

    AJS.$("[name=user-checkbox]").click(function() {
       AJS.$(this).children()[0].click();
    });
   
    function updateSelectedButton() {
        var sel=getSelectedUsers().length;
        if (sel > 0) {
            AJS.$("#addToSelected").attr("disabled", false);
            AJS.$("[name=selectedCount]").text(AJS.I18n.getText("vacationmanager.action.manage.users.action.bulk.selected.rows", sel));
            setBulkOpeartionButtonsEnabled(true);
        } else {
            AJS.$("#addToSelected").attr("disabled", true);
            AJS.$("[name=selectedCount]").text(AJS.I18n.getText("vacationmanager.action.manage.users.action.bulk.selected.rows", 0));
            setBulkOpeartionButtonsEnabled(false);
        }
    }
    
    function setBulkOpeartionButtonsEnabled(isEnabled) {
        AJS.$("#bulkOperations").attr("aria-disabled", (isEnabled==true)?null:"true");
    }
    
    // add user to group
    var addUsersDialog = VacmanDialogs.initExistingDialog("#addUsersDialog");

    AJS.$("#addUsersButton").click(function() {
        addUsersDialog.getElementByName("userNames").val("");
        addUsersDialog.show();
    });

    // remove user from group
    var removeUserDialog = VacmanDialogs.initExistingDialog("#removeUserDialog");
    
    AJS.$("[name=removeUserButton]").click(function() {
        var userName = AJS.$(this).attr("userName");
        removeUserDialog.getElementByName("userText").html(AJS.I18n.getText("vacationmanager.action.manage.users.dialog.remove.user.text", userName));
        removeUserDialog.getElementByName("userNames").val(userName);
        removeUserDialog.show();
    });

    // assign holiday scheme
    var assignHolidaySchemeDialog = VacmanDialogs.initExistingDialog("#assignHolidaySchemeDialog");

    AJS.$("[name=assignHolidaySchemeButton]").click(function() {
        var userName = AJS.$(this).attr("userName");
        var schemeId = AJS.$(this).attr("schemeId");
        assignHolidaySchemeDialog.getElementByName("usersText").text(userName);
        assignHolidaySchemeDialog.getElementByName("userNames").val(userName);
        assignHolidaySchemeDialog.getElementByName("schemeId").val(schemeId);
        assignHolidaySchemeDialog.show();
    });
    
    AJS.$("[name=bulkAssignHolidaySchemeButton]").click(function () {
        var schemeId = assignHolidaySchemeDialog.getElementByName("schemeId").find("option:first").val();
        assignHolidaySchemeDialog.getElementByName("usersText").text(getSelectedUsers().join(", "));
        assignHolidaySchemeDialog.getElementByName("userNames").val(getSelectedUsers().join(";"));
        assignHolidaySchemeDialog.getElementByName("schemeId").val(schemeId);
        assignHolidaySchemeDialog.show();
    });
    
    assignHolidaySchemeDialog.getForm().submit(function(e) {
        e.preventDefault();
    
        var params = {userNames: assignHolidaySchemeDialog.getElementByName("userNames").val().split(";"),
                schemeId: assignHolidaySchemeDialog.getElementByName("schemeId").val()
        }
    
        jQuery.ajax({
            type : "PUT",
            url : AJS.contextPath() + "/rest/vacation-manager/1.0/vacman-user/holidays/bulk",
            data : JSON.stringify(params),
            dataType : "json",
            contentType: 'application/json; charset=utf-8',
            async : true
        }).done(function(data) {
            var newSchemeName = assignHolidaySchemeDialog.getElementByName("schemeId").find("option[value="+data.schemeId+"]").text();
            
            for (var i=0; i<data.userNames.length; i++) {
                var userName = data.userNames[i];
                var schemeLink = "<a href='VacationManager.ViewHolidayScheme.jspa?schemeId="+data.schemeId+"'>"+_.escape(newSchemeName)+"</a>";
                usersTable.$("tr[user-name="+userName+"]").find("[data-cell-type=holiday-scheme]").html(schemeLink)
            }
        });
    });
    
    // assign workweek scheme
    var assignWorkweekSchemeDialog = VacmanDialogs.initExistingDialog("#assignWorkweekSchemeDialog");

    AJS.$("[name=assignWorkweekSchemeButton]").click(function() {
        var userName = AJS.$(this).attr("userName");
        var schemeId = AJS.$(this).attr("schemeId");
        assignWorkweekSchemeDialog.getElementByName("usersText").text(userName);
        assignWorkweekSchemeDialog.getElementByName("userNames").val(userName);
        assignWorkweekSchemeDialog.getElementByName("schemeId").val(schemeId);
        assignWorkweekSchemeDialog.show();
    });
    
    AJS.$("[name=bulkAssignWorkweekSchemeButton]").click(function () {
        var schemeId = assignWorkweekSchemeDialog.getElementByName("schemeId").find("option:first").val();
        assignWorkweekSchemeDialog.getElementByName("usersText").text(getSelectedUsers().join(", "));
        assignWorkweekSchemeDialog.getElementByName("userNames").val(getSelectedUsers().join(";"));
        assignWorkweekSchemeDialog.getElementByName("schemeId").val(schemeId);
        assignWorkweekSchemeDialog.show();
    });
    
    assignWorkweekSchemeDialog.getForm().submit(function(e) {
        e.preventDefault();
    
        var params = {userNames: assignWorkweekSchemeDialog.getElementByName("userNames").val().split(";"),
                schemeId: assignWorkweekSchemeDialog.getElementByName("schemeId").val()
        }
    
        jQuery.ajax({
            type : "PUT",
            url : AJS.contextPath() + "/rest/vacation-manager/1.0/vacman-user/workweek/bulk",
            data : JSON.stringify(params),
            dataType : "json",
            contentType: 'application/json; charset=utf-8',
            async : true
        }).done(function(data) {
            var newSchemeName = assignWorkweekSchemeDialog.getElementByName("schemeId").find("option[value="+data.schemeId+"]").text();
            
            for (var i=0; i<data.userNames.length; i++) {
                var userName = data.userNames[i];
                var schemeLink = "<a href='VacationManager.ViewWorkweekScheme.jspa?schemeId="+data.schemeId+"'>"+_.escape(newSchemeName)+"</a>";
                usersTable.$("tr[user-name="+userName+"]").find("[data-cell-type=workweek-scheme]").html(schemeLink)
            }
        });
    });

    var columnsDef = {textFilter: [TableColumnsEnum.fullname, TableColumnsEnum.username, TableColumnsEnum.teams],
            		selectFilter: [TableColumnsEnum.holidayScheme, TableColumnsEnum.workweekScheme]};
    
	function prepareColumn(column, columnName) {
        var columnId = column.index();

        if (VMQuery.inArray(columnId, columnsDef.selectFilter) >= 0) {
            var placeholder = AJS.I18n.getText("vacationmanager.datatables.filter.placeholder") + " " + column.header().textContent;
            var showAll = AJS.I18n.getText("vacationmanager.datatables.filter.show.all");
            var select = VM$('<select class="vm-input vm-input-filter"><option value="">' + placeholder + '</option><option value="">' + showAll + '</option></select>');
            select.attr("name", "filter_" + columnName);
            select.appendTo( VM$(column.footer()).empty() );
            select.change(function () {
                var val = VMQuery.fn.dataTable.util.escapeRegex(VM$(this).val());
                column.search( val ? '^'+val+ '$' : '', true, false ).draw();
            });

            column.data().unique().sort().each( function (text) {
                var name = VM$(text).text();
                select.append( '<option value="'+name+'">'+_.escape(name)+'</option>' )
            } );
            select.change();
            select.children().first().attr("disabled", "disabled")
        } else if (VMQuery.inArray(columnId, columnsDef.textFilter) >= 0) {
            var placeholder = AJS.I18n.getText("vacationmanager.datatables.filter.placeholder") + " " + column.header().textContent;
            var input = VM$('<input class="vm-input vm-input-filter" type="text" placeholder="'+placeholder+'" />');
            input.attr("name", "filter_" + columnName);
            input.appendTo( VM$(column.footer()).empty() ).on( 'keyup change', function () {
                if ( column.search() !== this.value ) {
                    column.search( this.value ).draw();
                }
            } );
            input.change();
        }
	}

	var usersTable = VM$('#usersTable').DataTable({
		columnDefs: [
		   { orderable: false, targets: [TableColumnsEnum.checkbox, TableColumnsEnum.actions] },
		   { name: "fullname", targets: [TableColumnsEnum.fullname] },
		   { name: "holidayscheme", targets: [TableColumnsEnum.holidayScheme] },
		   { name: "workweekscheme", targets: [TableColumnsEnum.workweekScheme] }
		],
		order: [ [TableColumnsEnum.fullname, 'asc'] ],
		language: datatablesLangObject,
        initComplete: function () {
            var columns = this.fnSettings()["aoColumns"];
            this.api().columns().every( function () {
            	prepareColumn(this, columns[this.index()].name);
            } );
        }
    });
	
    usersTable.$("input[name='userCheckbox']:checkbox").each(function () {
        AJS.$(this).change(updateSelectedButton);
     });
	   
    usersTable.on( 'search.dt', updateSelectedButton);
    updateSelectedButton();

    function applyFilters() {
	    var urlProps = VMQuery.url("?");
	    for (var prop in urlProps) {
	    	if (prop.includes("filter_")) {
	    	    var selectedValue = urlProps[prop];
	    	    VMQuery("[name="+prop).val(selectedValue);
	    	    VMQuery("[name="+prop).trigger("change");
	    	}
		}
    }
    
    applyFilters();

});
