var WorkweekSchemesDialogs = function() {
    
    function initAddNewSchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Workweek.SchemesDialogs.addNewSchemeDialog());

        AJS.$("[name=newWorkweekSchemeButton]").click(function() {
            dialog.getElementByName("newSchemeName").val("");
            dialog.show();
        });
    }

    function initCopySchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Workweek.SchemesDialogs.copySchemeDialog());

        AJS.$("[name=copyWorkweekSchemeButton]").click(function() {
            var schemeId = AJS.$(this).attr("scheme-id");
            var schemeName = AJS.$(this).attr("scheme-name");
            dialog.getElementByName("schemeSourceName").text(schemeName);
            dialog.getElementByName("newSchemeName").val(AJS.I18n.getText("vacationmanager.action.manage.workweek.schemes.copy.scheme.dest.name.copy.of", schemeName));
            dialog.getElementByName("schemeId").val(schemeId);
            dialog.show();
        });
    }

    function initDeleteSchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Workweek.SchemesDialogs.deleteSchemeDialog());

        AJS.$("[name=deleteWorkweekSchemeButton]").click(function() {
            var schemeId = AJS.$(this).attr("scheme-id");
            var schemeName = AJS.$(this).attr("scheme-name");
            dialog.getElementByName("deleteText").html(AJS.I18n.getText('vacationmanager.action.manage.holiday.schemes.delete.confirmation.text', schemeName));
            dialog.getElementByName("schemeId").val(schemeId);
            dialog.show();
        });

    }
    
    function initEditSchemeNameDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Workweek.SchemesDialogs.editSchemeNameDialog());

        AJS.$("[name=editWorkweekSchemeButton]").click(function() {
            dialog.getElementByName("newSchemeName").val(AJS.$(this).attr("scheme-name"));
            dialog.getElementByName("schemeId").val(AJS.$(this).attr("scheme-id"));
            dialog.show();
        });
    }

  function initEditSchemeTypeDialog() {
    var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Workweek.SchemesDialogs.editSchemeTypeDialog());

    AJS.$("[name=editWorkweekSchemeTypeButton]").click(function() {
      var schemeType = AJS.$(this).attr('scheme-type');

      AJS.$('option[value=' + schemeType + ']').attr('selected', 'selected');
      dialog.getElementByName('schemeId').val(AJS.$(this).attr("scheme-id"));
      dialog.show();
    });
  }

    return {        
        initAddNewSchemeDialog:initAddNewSchemeDialog,
        initCopySchemeDialog:initCopySchemeDialog,
        initDeleteSchemeDialog:initDeleteSchemeDialog,
        initEditSchemeNameDialog:initEditSchemeNameDialog,
        initEditSchemeTypeDialog:initEditSchemeTypeDialog
    }
}();
