function VacationManagerHourlyLeaveFields(container, issueContainerUtils) {

    var startDateTimeCfId = container.find('input[name=startDateTimeCfId]').val();
    var minutesPickerCfId = container.find('input[name=minutesPickerCfId]').val();
    var startDateTimePicker = container.find('#customfield_' + startDateTimeCfId);
    var minutesPicker = container.find('select[name=customfield_' + minutesPickerCfId + ']');
    var allPickerOptions = minutesPicker.children();

    startDateTimePicker.change(onStartDateTimePickerChange);
    issueContainerUtils.getReporterField().change(onReporterChange);

    function getUserId() {
        return parseInt(container.find('input[name=userId]').val(), 10);
    }

    function onStartDateTimePickerChange(event) {
        if (!event.target.value) {
            return;
        }

        var selectedDateString = event.target.value;
        issueContainerUtils.getUserWorkdayMinutes(issueContainerUtils.getReporterName(), selectedDateString)
          .then(function(userWorkday) {
        	  updateMinutesPickerOptionsForSelectedDay(userWorkday.workMinutes);
    	  });
    }

    function updateMinutesPickerOptionsForSelectedDay(workMinutes) {
        var optionsToSet = getOptionsForSelectedDay(workMinutes);

        var selectedOptionValue = minutesPicker.children(':selected').val();
        minutesPicker
          .empty()
          .append(optionsToSet)
          .val(selectedOptionValue);
    }

    function getOptionsForSelectedDay(workMinutesForSelectedDay) {
        var optionsToSet = [];
        for (var i = 0; i < allPickerOptions.length; i++) {
            if (parseInt($(allPickerOptions[i]).val(), 10) < workMinutesForSelectedDay) {
                optionsToSet.push(allPickerOptions[i]);
            }
        }
        return optionsToSet;
    }
    
    function onReporterChange() {
    	issueContainerUtils.getUserWorkdayMinutes(issueContainerUtils.getReporterName())
        .then(setMaxReporterMinutesInMinutesPicker);
    }
    
    function setMaxReporterMinutesInMinutesPicker(userWorkdays) {
    	if (userWorkdays && userWorkdays.workweekMinutes) {
    		var maxMinutes = 0;
    		AJS.$.each(userWorkdays.workweekMinutes, function(day, minutes) {
    			maxMinutes = Math.max(maxMinutes, minutes);
			})
			updateMinutesPickerOptionsForSelectedDay(maxMinutes);
    	}
    }

    onReporterChange();

}
